<?php
	
	class LSQ_GF {
			
		public function __construct( $AccessKey = null, $SecretKey = null, $apidomain = null ) {
			
			$this->akey = $AccessKey;
			$this->skey = $SecretKey;
			$this->apidomain = $apidomain;
			
		}

		/**
		 * User Authentication.
		 * 
		 * @access public
		 * @static
		 * @param string $AccessKey (default: NULL)
		 * @param string $SecretKey (default: NULL)
		 * @return true or false
		 */
		public function user_authentication() {

			$AccessKey = $this->akey;
			
			$SecretKey = $this->skey;
			
			$apidomain = $this->apidomain;
			
			/* User Authentication */
			$url = $apidomain.'Authentication.svc/UserByAccessKey.Get?accessKey='.$AccessKey.'&secretKey='.$SecretKey;
			
			/* Execute request. */
			$response = wp_remote_request( $url , array(
				'method' => 'GET',
				'timeout' => 100,
			) );
			
			if ( is_wp_error( $response ) ) {	
				die( 'Request failed. '. json_encode($response->get_error_messages()) );	
			} else {
				if($response['response']['code']  == '200'){
					return true;
				} else {
					return false;
				}			
			}		
		}
		
		
		/**
		 * Get the list of users.
		 * 
		 * @access public
		 * @return array $users
		 */
		public function get_users() {

			$url = $this->apidomain.'UserManagement.svc/Users.Get?accessKey='.$this->akey.'&secretKey='.$this->skey;
			
			$response = wp_remote_request( $url , array(
				'method' => 'GET'
			) );
			
			/* If WP_Error, die. Otherwise, return JSON. */
			if ( is_wp_error( $response ) ) {
				
				die( 'Request failed. '. $response->get_error_messages() );
				
			} else {
	
					$response_body = json_decode( $response['body'], true );
					return  $response_body;
						
			}
			
		}
		/**
		 * Get the Lead Meta Data
		 * 
		 * @access public
		 * @return array $users
		 */
		public function get_mete_data() {

			$url = $this->apidomain.'LeadManagement.svc/LeadsMetaData.Get?accessKey='.$this->akey.'&secretKey='.$this->skey;
			
			$response = wp_remote_request( $url , array(
				'method' => 'GET'
			) );
			
			/* If WP_Error, die. Otherwise, return JSON. */
			if ( is_wp_error( $response ) ) {
				
				die( 'Request failed. '. $response->get_error_messages() );
				
			} else {
	
					$response_body = json_decode( $response['body'], true );
					return  $response_body;
						
			}
			
		}		
		
		public function get_activity_type() {

			$url = $this->apidomain.'ProspectActivity.svc/ActivityTypes.Get?accessKey='.$this->akey.'&secretKey='.$this->skey;
			
			$response = wp_remote_request( $url , array(
				'method' => 'GET'
			) );
			
			/* If WP_Error, die. Otherwise, return JSON. */
			if ( is_wp_error( $response ) ) {
				
				die( 'Request failed. '. $response->get_error_messages() );
				
			} else {
	
					$response_body = json_decode( $response['body'], true );
					return  $response_body;
						
			}
			
		}
		
		/**
		 * Insert new record.
		 * 
		 * @access public
		 * @return array
		 */
		public function insert_record($lead, $akey = NULL, $skey = NULL) {
			if($akey){ $accessKey = $akey; } else { $accessKey = $this->akey; }
			if($skey){ $secretKey = $skey; } else { $secretKey = $this->skey; }
			
			$request_url = $this->apidomain.'LeadManagement.svc/Lead.Capture?accessKey='.$accessKey.'&secretKey='.$secretKey;
			$json_data = json_encode($lead,true);

			
			$response = wp_remote_request( $request_url, array( 
				'method'  => 'POST',
				'headers' => array('Content-Type' => 'application/json','Content-Length' => strlen($json_data)),
				'body'    => $json_data,
				'timeout' => 20
			) );
			
			if ( is_wp_error( $response ) ) {	
				return $response;
			} else {
				if($response['response']['code']  == '200'){
					$response_body = json_decode( $response['body'], true );
					return  $response_body;
				} else {
					$response_body = json_decode( $response['body'], true );
					return  $response_body;
				}
			}
		}		
		
		public function insert_activity($activityDetails,$akey = NULL, $skey = NULL) {
			if($akey){ $accessKey = $akey; } else { $accessKey = $this->akey; }
			if($skey){ $secretKey = $skey; } else { $secretKey = $this->skey; }

			$request_url = $this->apidomain.'ProspectActivity.svc/Create?accessKey='.$accessKey.'&secretKey='.$secretKey;
			$json_data = json_encode($activityDetails,true);
			
			$response = wp_remote_request( $request_url, array( 
				'method'  => 'POST',
				'headers' => array('Content-Type' => 'application/json','Content-Length' => strlen($json_data)),
				'body'    => $json_data,
				'timeout' => 20
			) );
			
			if ( is_wp_error( $response ) ) {	
				die( 'Request failed. '. $response->get_error_messages() );	
			} else {
				if($response['response']['code']  == '200'){
					$response_body = json_decode( $response['body'], true );
					return  $response_body;
				} else {
					$response_body = json_decode( $response['body'], true );
					return  $response_body;
				}
			}
		}
		
		public function get_dynamic_field_map_fields_lsq($feed){
			$leadCustomFields = rgars( $feed, 'meta/leadCustomFields' );
			$array = array();
			foreach($leadCustomFields as $fields){
				$key = $fields['key'];
				$val = $fields['value'];
				
				if (array_key_exists($key,$array)){
					if(is_array($array[$key])){
						array_push($array[$key],$val);
					} else {
						$array[$key] = array($array[$key],$val);
					}

				} else {
					$array[$key] = $val;
				}
				
			}
			return $array;
		}		
		
		public function get_field_value( $form, $entry, $value ){
			$ent =  array_filter($entry, function($val) { return $val !== ''; });
			return $entry[$value];
		}
	}