<?php
	
/*
Plugin Name: Gravity Forms LeadSquared Add-On Custom
Plugin URI: http://help.leadsquared.com
Description: Map LeadSquared fields to corresponding gravity from fields.
Version: 1.6
Author: LeadSquared
Author URI: http://www.LeadSquared.com
Text Domain: gravityformsleadsquared

------------------------------------------------------------------------
*/

define( 'GF_LeadSquared_VERSION', '1.3' );

add_action( 'gform_loaded', array( 'GF_LeadSquared_Bootstrap', 'load' ), 5 );

class GF_LeadSquared_Bootstrap {

	public static function load() {
		require_once( 'class-gf-leadsquared.php' );
		GFAddOn::register( 'GFleadsquared' );
	}

}

function gf_leadsquared() {
	return GFleadsquared::get_instance();
}

add_action( 'gform_entry_detail_content_after', 'leadsquared_gf_meta_error', 10, 2 );
function leadsquared_gf_meta_error( $form, $entry ) {
	
	$error_type = gform_get_meta( $entry['id'],'leadsquared_error_type' ); 
	$leadsquared_lead_id = gform_get_meta( $entry['id'],'leadsquared_lead_id' ); 
	if($error_type){
		?>
		<table class="widefat fixed entry-detail-view" cellspacing="0">
			<thead>
				<tr>
					<th>LeadSquared Error</th>
				</tr>
			</thead>
			<tbody>
				<tr>
					<td class="entry-view-field-name">Error Message</td>
                 </tr>
				<tr>
					<td><?php $error_message = gform_get_meta( $entry['id'],'leadsquared_error_message' ); echo $error_message;?></td>
				</tr>
				<tr>
					<td class="entry-view-field-name">Error Type</td>
                 </tr>
				<tr>
					<td><?php echo $error_type;?></td>
				</tr>
				<tr>
					<td class="entry-view-field-name">JSON</td>
                 </tr>
				<tr>
					<td><?php $json_data = gform_get_meta( $entry['id'],'leadsquared_json_data' ); echo $json_data;?></td>
				</tr>
			</tbody>
		</table>
		<?php
	} else if ($leadsquared_lead_id){
				?>
		<table class="widefat fixed entry-detail-view" cellspacing="0">
			<thead>
				<tr>
					<th>LeadSquared Success</th>
				</tr>
			</thead>
			<tbody>
				<tr>
					<td class="entry-view-field-name">Lead Id</td>
                 </tr>
				<tr>
					<td><?php $error_message = gform_get_meta( $entry['id'],'leadsquared_lead_id' ); echo $error_message;?></td>
				</tr>
				<?php $leadsquared_activity_id = gform_get_meta( $entry['id'],'leadsquared_activity_id' );  if($leadsquared_activity_id){ ?>
				<tr>
					<td class="entry-view-field-name">Activity id</td>
                 </tr>
				 <tr>
					<td><?php echo $leadsquared_activity_id;?></td>
				</tr>
				<?php } ?>
				<tr>
					<td class="entry-view-field-name">JSON</td>
                 </tr>
				<tr>
					<td><?php $json_data = gform_get_meta( $entry['id'],'leadsquared_json_data' ); echo $json_data;?></td>
				</tr>
			</tbody>
		</table>
		<?php
	} 

}


function add_this_script_footer(){ 
	?>
	<script type='text/javascript' >
	function SetProspectID(){
		  if (typeof(MXCProspectId) !== "undefined")
		  jQuery('.ProspectID input').attr('value',MXCProspectId);
		 }
		  window.onload = function()  
		 {
		  setTimeout (SetProspectID , 2000);
		  };
	</script>
	<?php 
} 

add_action('wp_footer', 'add_this_script_footer',100); ?>